<?php
/**
 * @package	BadBot Protection
 * @copyright	Copyright (C) 2018 SiteGuarding.com. All rights reserved.
 * @GNU General Public License
 */
defined('_JEXEC') or die('Restricted access');
 
class com_badbotprotectionInstallerScript
{
	function install($parent) 
	{

        jimport('joomla.installer.installer');
        $src_plugins = dirname(__FILE__). DIRECTORY_SEPARATOR .'plugin';


        $installer = new JInstaller;

        $result = $installer->install($src_plugins);
        //$status->plugins[] = array('name'=>'badbotprotection','group'=>'content', 'result'=>$result);

	$db = JFactory::getDBO();
        $db->setQuery("UPDATE #__extensions SET enabled = '1' WHERE `element` = 'badbotprotection' AND `type` = 'plugin'");
        $db->execute();


	}
	
	
	function uninstall($parent) 
	{
                com_badbotprotectionInstallerScript::uninstall_badbot_codes(JPATH_ROOT . DIRECTORY_SEPARATOR . '.user.ini',"; SiteGuarding Firewall Block","; END SiteGuarding Firewall Block" );
                com_badbotprotectionInstallerScript::uninstall_badbot_codes(JPATH_ROOT . DIRECTORY_SEPARATOR . '.htaccess',"# SiteGuarding Firewall Block","# END SiteGuarding Firewall Block" );
                
                sleep(1);
                
		$tools_file = JPATH_ROOT . DIRECTORY_SEPARATOR . 'siteguarding_tools.php';
		$tools_folder = JPATH_ROOT . DIRECTORY_SEPARATOR . 'webanalyze';
		
		if (JFolder::exists($tools_folder)) JFolder::delete($tools_folder);
		if (JFile::exists($tools_file)) JFile::delete($tools_file);

		jimport('joomla.installer.installer');
		$db = JFactory::getDBO();	
		$db->setQuery('SELECT `extension_id` FROM #__extensions WHERE `type` = "plugin" AND `element` = "badbotprotection" AND `folder` = "content"');
        $id = $db->loadResult();
        if($id)
        {
            $installer = new JInstaller;
            $result = $installer->uninstall('plugin', $id , 1);
        }

	}
        
        public static function uninstall_badbot_codes($filename,$start,$end ){
            
            $filesize = filesize($filename);
            
            if($filesize == 0){
                return;
            }
            
            $handle = fopen($filename, "rb");
            $contents = fread($handle, $filesize);
            fclose($handle);
            
            $pos_start = strpos($contents, $start);
            $pos_end = strrpos($contents, $end);
            $margin = strlen($end);
            
            $diff = $pos_end - $pos_start;
            
            if ($pos_start !== false && $pos_end !== false && $diff > 100){
                $new_content = substr($contents, 0, $pos_start).substr($contents, $pos_end + $margin, strlen($contents) );
                
                $fp = fopen($filename, 'w');
		fwrite($fp, $new_content);
		fclose($fp);
            }
        }
	

}
